]> git.pld-linux.org Git - packages/rpm.git/blame - rpm.macros
- %_clean_env: no need to quote : . _ -
[packages/rpm.git] / rpm.macros
CommitLineData
b52fc1f1 1# $Revision$, $Date$
cc2b296f 2# PLD Linux rpm macros
a8bf9720 3
90c0eaed 4%epoch 0
31b569b6 5%x8664 x86_64 amd64 ia32e
cd33aab7 6
a544555d 7# kernel compiler
6f86c45e 8%kgcc %{__cc}
cabacfeb 9%kgcc_package gcc
a544555d 10
7104afbf
ER
11# compiler version
12%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
48a39d1d 13%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
7104afbf 14
4343a1f7
ER
15%__rm /bin/rm --interactive=never
16
5f9f9bd7 17# Build system path macros.
18#
8af1c6f5
JB
19%__autoconf autoconf %{?debug:-Wall}
20%__automake automake -a -c -f --foreign
429d047e 21%__autopoint autopoint --force
22
aad1c8e4 23%__gettextize { \
4cd84746 24 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
31b569b6 25 gettextize --copy --force --no-changelog; \
93bce43f 26 else \
31b569b6 27 gettextize --copy --force --no-changelog --intl; \
4cd84746
JB
28 fi; \
29 if [ ! -f po/Makevars ]; then \
31b569b6 30 cp -f po/Makevars{.template,}; \
4cd84746 31 fi; \
4cd84746 32}
429d047e 33
34%__glib_gettextize glib-gettextize --copy --force
35%__gnome_doc_common gnome-doc-common --copy
db1adf13 36%__gnome_doc_prepare gnome-doc-prepare --copy --force
429d047e 37%__gtkdocize gtkdocize --copy
38%__intltoolize intltoolize --copy --force
098ff935 39%__libtoolize libtoolize --copy --force --install
5f9f9bd7 40
702e8027 41# Path to top of build area.
135188cb 42%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
702e8027 43
38e780ca
ER
44# The number of cvs changelog entries kept when building package.
45%_buildchangelogtruncate 20
46
bd1cd543 47%dependencytracking %{nil}
31b569b6 48
073ae3ba
ER
49# Relations between package names that cause dependency loops
50# with legacy packages that cannot be fixed. Relations are
51# specified as
52# p>q
53# where package p has a Requires: on something that package q Provides:
54#
55# XXX Note: that there cannot be any whitespace within the string "p>q",
56# and that both p and q are package names (i.e. no version/release).
57%_dependency_whiteout %{nil}
58
9ba56d1b 59%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
1e66cebd 60 && RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
96925e1b 61 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$(($RPM_BUILD_NCPUS * 2))")
cece03f9 62
63#-----------------------------------------------------------------
64#
65# (re)definition of %{rpm*flags} with %filterout_* support
7c9f98ce
ER
66# BuildRequires: awk
67# BuildRequires: rpmbuild(macros) >= 1.315
cece03f9 68#
69# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
a0bf497e 70# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
71# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
63c5d135 72# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
a0bf497e 73# %rpmldflags = %optldflags - %filterout_ld
cece03f9 74#
75# Regular expressions are supported, but to avoid some character be treated
76# as regular expression it must be escaped twice.
77
78%filter_out \
bf66145e 79 for (i = 1; i in I; i++) { A=0; \
cece03f9 80 for (f in F) { \
81 if (I[i] ~ "^" F[f] "$") A=1; \
82 }; \
83 if (!A) printf(I[i] FS); \
84 }
85
86%rpmcflags %(awk 'BEGIN {
87 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
a0bf497e 88 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
cece03f9 89 %{filter_out}
90}')
91
92%rpmcxxflags %(awk 'BEGIN {
a0bf497e 93 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
94 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
cece03f9 95 %{filter_out}
96}')
97
63c5d135
AM
98%rpmcppflags %(awk 'BEGIN {
99 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
100 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
101 %{filter_out}
102}')
103
cece03f9 104%rpmldflags %(awk 'BEGIN {
b699ccff 105 split("%{?optldflags}",I);
cece03f9 106 split("%{?filterout_ld}",F)
107 %{filter_out}
108}')
109
111942c6 110# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
111# but, don't use it, better use gcc as linker
112%ld_rpmldflags %(awk 'BEGIN {
113 split("%{rpmldflags}",F);
114 for (f in F) {
115 s = F[f];
116 if (s ~ /^-Wl,/) {
117 s = substr(s,5);
118 gsub(/,/," ",s);
119 };
120 printf(s FS);
121 };
122}')
123
267cb3a3 124#-----------------------------------------------------------------
125#
126# Generate a command which cleans environment, leaving only the
127# most important variables.
128# If any spec requires any additional environment it should
129# redefine %_preserve_env in following manner:
130#
131# # ADDITIONAL_VAR is required because [a good reason here]
132# %{expand:%%define _preserve_env %_preserve_env ADDITIONAL_VAR}
133
4054dec0 134%_preserve_env PATH HOME TMP TMPDIR
267cb3a3 135
c4a2fa20 136%_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
4054dec0
ER
137 split("%{?_preserve_env:%_preserve_env}", P);
138 for (i in P) {
139 p = P[i];
140 if (ENVIRON[p]) {
c4a2fa20 141 split( ENVIRON[p], V, "" );
142 val = p "=";
143 for ( j = 1; j in V; j++ ) {
144 v = V[j];
145 if ( v == q )
146 v = qq;
147 else if ( v == "\\"" )
148 v = q2q;
149 else if ( v == "\\\\" )
150 v = "\\\\\\\\";
151 else
94fc2959 152 gsub( "[^a-zA-Z0-9/:._-]", "\\"&\\"", v );
c4a2fa20 153 val = val "" v;
154 }
155 printf( val " " );
267cb3a3 156 }
157 }
158}')
159
cd33aab7 160#-----------------------------------------------------------------
9f0287b5 161%configure2_13 { \
cd33aab7
AM
162 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
163 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
164 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
af18d245 165 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
cd33aab7 166 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
d4392e78 167 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
63c5d135 168 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
4eac2e49
AM
169 %{?__cc:CC="%{__cc}" ; export CC ; } \
170 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
5b0f0ac9 171 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
fa74a11c 172 --host=%{_target_platform} \
cd33aab7
AM
173 --prefix=%{_prefix} \
174 --exec-prefix=%{_exec_prefix} \
175 --bindir=%{_bindir} \
176 --sbindir=%{_sbindir} \
177 --sysconfdir=%{_sysconfdir} \
178 --datadir=%{_datadir} \
179 --includedir=%{_includedir} \
180 --libdir=%{_libdir} \
181 --libexecdir=%{_libexecdir} \
182 --localstatedir=%{_localstatedir} \
183 --sharedstatedir=%{_sharedstatedir} \
184 --mandir=%{_mandir} \
185 --infodir=%{_infodir} \
c3420100 186 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 187 %{dependencytracking} \
cd33aab7
AM
188}
189
53c34296 190%__cmake /usr/bin/cmake
29771119
ER
191%cmake { \
192CC="%{__cc}" \
193CXX="%{__cxx}" \
194CFLAGS="%{rpmcflags}" \
195CXXFLAGS="%{rpmcxxflags}" \
ff219781 196LDFLAGS="%{rpmldflags}" \
53c34296
ER
197%{__cmake} \
198}
199
200# override __scons to add -j4 in your ~/.rpmmacros for parallel make
201%__scons /usr/bin/scons
202%scons { \
203%{__scons} \
13eb0f84
ER
204 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
205 CFLAGS="${CFLAGS:-%rpmcflags}" \
206 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
207 FFLAGS="${FFLAGS:-%rpmcflags}" \
63c5d135 208 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
13eb0f84
ER
209 %{?__cc:CC="%{__cc}"} \
210 %{?__cxx:CXX="%{__cxx}"} \
211 libsuffix=%{_lib} \
212 prefix=%{_prefix} \
29771119
ER
213}
214
ac093701 215# waf. see waf.spec
53c34296 216# override __waf to add -j4 in your ~/.rpmmacros for parallel make
ac093701
ER
217%__waf /usr/bin/waf
218%waf { \
ac093701
ER
219CC="%{__cc}" \
220CXX="%{__cxx}" \
1624498d 221CPP="%{__cpp}" \
ac093701
ER
222CFLAGS="%{rpmcflags}" \
223CXXFLAGS="%{rpmcxxflags}" \
224%{__waf} \
ac093701
ER
225}
226
85f82bec 227#----------------------------------------------------------------
b7626f51 228#%configure_cache 0
43f81f06 229%configure_cache_file %{buildroot}.configure.cache
7e4e3f2b 230
b8cf6778 231%configure {./configure \
85f82bec
AF
232 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
233 CFLAGS="${CFLAGS:-%rpmcflags}" \
af18d245 234 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
85f82bec 235 FFLAGS="${FFLAGS:-%rpmcflags}" \
d4392e78 236 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
63c5d135 237 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
4eac2e49
AM
238 %{?__cc:CC="%{__cc}"} \
239 %{?__cxx:CXX="%{__cxx}"} \
a9bea0f7 240 --host=%{_target_platform} \
85f82bec
AF
241 --build=%{_target_platform} \
242 --prefix=%{_prefix} \
243 --exec-prefix=%{_exec_prefix} \
244 --bindir=%{_bindir} \
245 --sbindir=%{_sbindir} \
246 --sysconfdir=%{_sysconfdir} \
247 --datadir=%{_datadir} \
248 --includedir=%{_includedir} \
249 --libdir=%{_libdir} \
250 --libexecdir=%{_libexecdir} \
251 --localstatedir=%{_localstatedir} \
252 --sharedstatedir=%{_sharedstatedir} \
253 --mandir=%{_mandir} \
254 --infodir=%{_infodir} \
c3420100 255 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 256 %{dependencytracking} \
b7626f51 257 %{?configure_cache:--cache-file=%{configure_cache_file}} \
85f82bec
AF
258}
259
9cd5fb46
ER
260# overload to insert debuginfo package
261%prep \
262%if 0%{?_enable_debug_packages}\
263%{debug_package}\
264%endif\
265%%prep\
266%{nil}
267
cd33aab7 268# Location of autoconf macros
742f3bc4 269%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
cd33aab7 270
32720a50 271# Location of omf files
742f3bc4 272%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
32720a50 273
c5eece2c 274# Location of pkgconfig files
a46897a7 275%_pkgconfigdir /usr/%{_lib}/pkgconfig
e2023017
JB
276# noarch pkgconfig files
277%_npkgconfigdir /usr/share/pkgconfig
c5eece2c 278
c917274d 279# Location of desktop files
280%_desktopdir /usr/share/applications
510f694c 281%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
c917274d 282
fb08fb4a 283# Location of pixmaps for applnk/desktop files
3a9bb008 284%_pixmapsdir /usr/share/pixmaps
cd33aab7 285
fb08fb4a 286# Location of themable icons for applnk/desktop files
986c3bcd 287%_iconsdir /usr/share/icons
288
c5eece2c
JB
289# Location of fonts directories
290%_fontsdir /usr/share/fonts
291
5cfcbc9e 292# Location of Gtk and associated libraries documentation
43f81f06 293%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
5cfcbc9e 294
eee08b2d 295# Location of KDE documentation
43f81f06 296%_kdedocdir %{_defaultdocdir}/kde/HTML
eee08b2d 297
a7cad6ae 298# unsermake script
299%__unsermake /usr/share/unsermake/unsermake
300
cd33aab7
AM
301# Current date
302%date %(LC_ALL="C" date +"%a %b %d %Y")
303
cd33aab7
AM
304# Example files, programs, scripts...
305%_examplesdir /usr/src/examples
306
7127e0fc 307# Alternative kernel type/version
c604d0a9 308%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
7127e0fc 309
bd63739a 310# The directory holding Linux kernel sources
c604d0a9 311%_kernelsrcdir /usr/src/linux%{_alt_kernel}
bd63739a 312
cd33aab7 313# If non-empty "debug" macro defined, add "dbg" suffix to release number
5b0f0ac9 314%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
cd33aab7 315
5b0f0ac9 316# Requires name = version-release
48c1bf9f 317%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
511ee4c6 318
135188cb
ER
319%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
320%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
321%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
d606f9ca
ER
322%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
323%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
324%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
511ee4c6 325
48c1bf9f
ER
326# XXX: why epoch 0 is stripped?
327%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
328%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
e478b9e7 329
a1551c98 330%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
8dea1306 331
332# kernel version-release handling
1c1268c5
ER
333%__kernel_ver %{expand:%%global __kernel_ver %( \\
334 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
335 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
336 echo ${Z:-ERROR}; \\
91897f8e 337)}%__kernel_ver
1c1268c5 338
a1551c98
ER
339%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
340%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
341%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
342%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
fd4d8ee0 343
63fcfda0
ER
344# `uname -r` to be used in @release field
345%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
346
c2c27a5a 347# sgml macros
31b569b6
ER
348%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
349%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
350%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
351%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
352%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
353%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
c2c27a5a 354%docbook_sgmlcat_fix() { for l in \
355'' \
356' -- default decl --' \
357'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
358' -- hacks for opensp --' \
359'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
360'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
361'' \
362; do echo $l; done >> %1 \
363}
364
31bd34a8
ER
365# vim - "
366
f3f40db8
ER
367# minimum file size needed for compressed documents.
368# just smaller files than this get larger when compressed.
cdbfc157
ER
369# some stats:
370# - 0 byte file compressed was 25 bytes .gz
371# - 39 byte file was compressed as 57
372# - with test/test.spec@man 158 byte file was compressed also 158
373%_min_compress_bytes 159
f3f40db8 374
cd33aab7
AM
375#-----------------------------------------------------------------
376# find and gzip all files in %{_mandir} and %{infodir}
377#
378# Requires: xargs, find
379#
380#%no_install_post_compress_docs 1
381%__spec_install_post_compress_docs { \
f67bd19e 382%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
026ed59b 383 for i in /usr/share/man /usr/X11R6/man; do \
cd33aab7 384 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
026ed59b 385 echo "Compress man pages: $i"; \
f3f40db8
ER
386 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
387 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
38e531f0
ER
388 find $RPM_BUILD_ROOT$i -type l | while read a; do \
389 m=$(readlink $a); \
390 rm -f $a; \
391 echo .so ${m##*/} > $a; \
392 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
393 done; \
f3f40db8 394 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
cd33aab7
AM
395 fi; \
396 done; \
91bfff1c
JB
397 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
398 echo "Compress info pages: %{_infodir}"; \
399 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
400 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
401 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
026ed59b 402 fi; \
f67bd19e 403}; __spec_install_post_compress_docs } }
cd33aab7
AM
404
405#-----------------------------------------------------------------
406# Strip executable binaries and shared object files
407#
408# Requires: find, awk, strip, cut, xargs
409#
ee170415
JB
410# Special macros which affect this process:
411#%no_install_post_strip 1 # disable stripping at all
412#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
413#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
414#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
415#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
416#
cd33aab7 417%__spec_install_post_strip {%{!?debug: \
f67bd19e 418%{!?no_install_post_strip:__spec_install_post_strip() { \
65e03cc0 419if [ -d "$RPM_BUILD_ROOT" ]; then \
31bd34a8
ER
420 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
421 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
422 if [ "$modulelist" ]; then \
423 modulecount=$(echo "$modulelist" | wc -l); \
7f1d3873 424 printf "Stripping %d kernel modules..." $modulecount; \
6cf69412
ER
425 echo "$modulelist" | xargs -l512 chmod u+w; \
426 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
427 echo "DONE"; \
428 fi; \
31bd34a8 429 fi; \
559c4907 430 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
d65f5d0e
JB
431 if [ -n "$filelist" ]; then \
432 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
433 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
434 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
ee170415 435 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
d65f5d0e 436 if [ -n "$elfexelist" ]; then \
fefadad0 437 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
d65f5d0e
JB
438 chmod u+w $elfexelist; \
439 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
440 echo "DONE"; \
441 fi; \
442 if [ -n "$elfsharedlist" ]; then \
fefadad0 443 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
d65f5d0e
JB
444 chmod u+w $elfsharedlist; \
445 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
446 echo "DONE"; \
447 fi; \
448 if [ -n "$archiveslist" ]; then \
fefadad0 449 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
d65f5d0e
JB
450 chmod u+w $archiveslist; \
451 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
452 echo "DONE"; \
453 fi; \
65e03cc0 454 fi; \
559c4907
ER
455 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
456 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
457 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
d65f5d0e 458 if [ -n "$filelist_all" ]; then \
fefadad0 459 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
ee170415 460 chmod u+w $filelist_all; \
d65f5d0e 461 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
fc87add2 462 echo "DONE"; \
cd33aab7 463 fi; \
d65f5d0e 464 if [ -n "$filelist_unneeded" ]; then \
fefadad0 465 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
ee170415 466 chmod u+w $filelist_unneeded; \
d65f5d0e 467 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
fc87add2 468 echo "DONE"; \
5b0f0ac9 469 fi; \
d65f5d0e 470 if [ -n "$filelist_debug" ]; then \
fefadad0 471 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
ee170415 472 chmod u+w $filelist_debug; \
d65f5d0e 473 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
fc87add2 474 echo "DONE"; \
f80cefa3 475 fi; \
f67bd19e 476fi; }; __spec_install_post_strip } } }
31b569b6 477
cc545e1a 478#-----------------------------------------------------------------
479# remove all RPATH from executable binaries and shared object files
480#
481# Requires: find, awk, cut, xargs, chrpath, uname
482#
ee170415
JB
483# Special macros which affect this process
484#%no_install_post_chrpath 1 # disable chrpath at all
485#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
486#
cc545e1a 487%__spec_install_post_chrpath {%{!?debug: \
f67bd19e 488%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
f80cefa3 489if [ -d "$RPM_BUILD_ROOT" ]; then \
559c4907 490 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
65e03cc0 491 if [ -n "$files" ]; then \
0faed11b 492 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
fd3a42b0 493 fi; \
65e03cc0 494 if [ -n "$objs" ]; then \
fefadad0 495 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
65e03cc0
ER
496 echo "$objs" | \
497 while read file; do \
498 rpath= ; \
499 chmod u+w "$file"; \
ebc04679 500 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
92a43428
AM
501 case $dir in \
502 '$ORIGIN' ) \
503 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
504 else rpath="$rpath:$dir" ; fi ; \
505 continue ; \
506 ;; \
507 esac ; \
b2ed5f3d
AM
508 newdir=$(readlink -m "$dir"); \
509 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
65e03cc0
ER
510 case $dir in \
511 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
512 echo "remove-rpath: $dir in $file"; \
513 ;; \
514 * ) \
515 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
516 else rpath="$rpath:$dir" ; fi ; \
517 ;; \
518 esac ; \
519 done ; \
520 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
521 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
522 done; \
523 fi; \
f67bd19e 524fi; }; __spec_install_post_chrpath } } }
31b569b6 525
f173029a
AM
526#-----------------------------------------------------------------
527# Find all shared object files with unresolved symbols. Warn
528# and terminate if any found (termination can be turned off by define).
529#%no_install_post_check_so 1
530%__spec_install_post_check_so { \
531 __spec_install_post_check_so() { \
532 fail=0; \
533 printf "Searching for shared objects with unresolved symbols..."; \
7643f7e1 534 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
1dcf239c 535 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
f173029a
AM
536 done ; \
537 echo " DONE"; \
c1f91a8d 538 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
f173029a
AM
539}; __spec_install_post_check_so }}
540
22a54b3e 541#-----------------------------------------------------------------
93b46c00 542# Find and gzip all kernel modules
543#
544# Requires: find
545#
43f81f06 546#%no_install_post_compress_modules 1
93b46c00 547%__spec_install_post_compress_modules { \
f67bd19e 548%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
9cf7c1b9 549 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
9cf7c1b9 550 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
551 if [ "$q" ]; then \
552 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
553 echo "$q" | xargs -r %{__gzip} -9nf; \
554 echo "DONE"; \
555 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
556 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
557 fi; \
31b569b6 558 fi; \
f67bd19e 559}; __spec_install_post_compress_modules } }
cd33aab7 560
e4d71427
ER
561# Remove common Perl files we don't package
562%__spec_install_post_perl_clean {\
563%{!?no_install_post_perl_clean: \
564%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
565} }
566
aad1c8e4 567#-----------------------------------------------------------------
cc6c554c 568# Update GConf2 schemas
aad1c8e4 569#
570# Requires: GConf2
571#
5b8ed3c0 572%gconf_schema_install() \
b7f351b9
ER
573 umask 022; \
574 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
575 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
2b633092 576%{nil}
5b8ed3c0 577
578%gconf_schema_uninstall() \
d143d064 579if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
31b569b6 580 umask 022; \
d143d064
ER
581 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
582 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
2b633092 583fi; \
429d047e 584%{nil}
585
586#-----------------------------------------------------------------
587# Update desktop MIME database
96999189 588# requires: desktop-file-utils
7ec40643 589%update_desktop_database() {{ \
429d047e 590 umask 022; \
db1adf13 591 /usr/bin/update-desktop-database -q; \
e26a0fcc
MB
592};} \
593%{nil}
429d047e 594
7ec40643
ER
595%update_desktop_database_post %update_desktop_database
596
597%update_desktop_database_postun() {{ \
2b633092 598if [ "$1" = "0" ]; then \
e26a0fcc 599 %update_desktop_database \
2b633092 600fi; \
e26a0fcc
MB
601};} \
602%{nil}
429d047e 603
db1adf13 604#-----------------------------------------------------------------
605# Update shared MIME info database
606# requires: shared-mime-info
607#
7ec40643 608%update_mime_database() {{ \
db1adf13 609 umask 022; \
610 /usr/bin/update-mime-database %{_datadir}/mime; \
e26a0fcc
MB
611};} \
612%{nil}
db1adf13 613
614#-----------------------------------------------------------------
615# Update icon cache
616# requires: gtk+
617#
7ec40643 618%update_icon_cache() {{ \
db1adf13 619 umask 022; \
8ffd1cc2 620 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
e26a0fcc
MB
621};} \
622%{nil}
db1adf13 623
429d047e 624#-----------------------------------------------------------------
625# Update scrollkeeper database
626# requires: scrollkeeper
627#
628%scrollkeeper_update_post() \
429d047e 629 /usr/bin/scrollkeeper-update -q; \
2b633092 630%{nil}
429d047e 631
632%scrollkeeper_update_postun() \
2b633092 633if [ "$1" = "0" ]; then \
429d047e 634 /usr/bin/scrollkeeper-update -q; \
2b633092 635fi; \
429d047e 636%{nil}
637
cd33aab7
AM
638#-----------------------------------------------------------------
639# post %install sequence:
640# - autodeps exceptions
641# - compress all man and info pages,
642# - strip all ELF executables and ELF shared objects if not %debug.
5b0f0ac9 643# - compress kernel modules if any
cd33aab7
AM
644
645###################################################################
646# Requires/Provides automation
f9e8b64d 647# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
a4852742 648#
fbbdca08
JB
649%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
650%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
651%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
652%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
653%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
a1551c98 654
a4852742
JB
655#%_noautocompressdoc %{nil}
656#
5b0f0ac9
MM
657%_missing_doc_files_terminate_build 1%{nil}
658%_unpackaged_files_terminate_build %{nil}
4c7d3ba4 659# (X)emacs support
42b7e5ac 660%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
a1551c98
ER
661%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
662%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
41a62699 663
984f6de6
JK
664%__php_provides %{nil}
665%__php_requires %{nil}
666%__perl_provides %{nil}
667%__perl_requires %{nil}
63b0a9d7 668%__mono_provides %{nil}
669%__mono_requires %{nil}
41a62699
AF
670
671# Perl specific macro definitions.
a1551c98
ER
672%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
673%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
674%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
675%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
676%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
677%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
41a62699 678
cb84f517 679# Ruby
a1551c98
ER
680%__ruby /usr/bin/ruby
681%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
682%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
683%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
684%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
685%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
686%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
687%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
7de443fe 688%ruby_rdocdir /usr/share/rdoc
a1551c98 689%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
5483bb35
ER
690%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
691%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
cb84f517 692
3da52f86 693%php_pear_dir /usr/share/pear
ef62b6ce 694%php_data_dir /usr/share/php
a1551c98
ER
695%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
696%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
697%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
41a62699 698
f73da51b 699# extract php/zend api versions
a1551c98
ER
700%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
701%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
702%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
703%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
704%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
705%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
706%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
6b2157a6
ER
707
708# helper macro
e255dfdc 709%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
6b2157a6
ER
710
711# macros for public use
712# for php extensions (php-pecl)
ab8d73ee 713%requires_php_extension %{__php_api_requires modules_api php_api_version} \
cc2b296f 714%{__php_api_requires zend_module_api} \
e255dfdc
ER
715%{__php_api_requires -v %php_major_version debug php_debug} \
716%{__php_api_requires -v %php_major_version thread-safety zend_zts}
ab8d73ee 717
6b2157a6
ER
718# for zend extensions
719%requires_zend_extension %{__php_api_requires zend_module_api} \
ab8d73ee 720%{__php_api_requires zend_extension_api} \
e255dfdc
ER
721%{__php_api_requires -v %php_major_version debug php_debug} \
722%{__php_api_requires -v %php_major_version thread-safety zend_zts}
6b2157a6 723
1c107a2d
ER
724# for php pdo modules (php-pecl-PDO_*)
725%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
726
e6ca24e8
ER
727# for using PHP post scripts. for PHP >= 5.0
728%php_webserver_restart \
729[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
febce2c9 730[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
b4080c85
ER
731if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
732 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
733 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
734 %service -q php-fcgi restart \
735 fi \
736fi \
e6ca24e8
ER
737%{nil}
738
739# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
740%php4_webserver_restart \
741[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
febce2c9 742[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
b4080c85
ER
743if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
744 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
745 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
746 %service -q php-fcgi restart \
747 fi \
748fi \
e6ca24e8
ER
749%{nil}
750
b89f672e 751# X.org helper macros
14109c0c
ER
752%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
753%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
754
a1551c98
ER
755%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
756%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
757%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
758%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
759%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
b89f672e 760
14109c0c 761%requires_xorg_xserver_extension \
08fe4a98
AM
762%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
763%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
764%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
765%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
14109c0c
ER
766%{nil}
767
768%requires_xorg_xserver_xinput \
08fe4a98
AM
769%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
770%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
771%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
772%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
14109c0c
ER
773%{nil}
774
775%requires_xorg_xserver_font \
08fe4a98
AM
776%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
777%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
778%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
779%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
14109c0c
ER
780%{nil}
781
782%requires_xorg_xserver_videodrv \
08fe4a98
AM
783%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
784%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
785%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
786%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
14109c0c 787%{nil}
b89f672e 788
41a62699
AF
789# Python specific macro definitions.
790# python main version
6e4fcea0 791%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
41a62699
AF
792
793# directories
6e4fcea0 794%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
31b569b6 795%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
a4f0b5e0 796%py_scriptdir %{py_prefix}/share/python%{py_ver}
31b569b6 797%py_incdir /usr/include/python%{py_ver}
3da52f86 798%py_sitedir %{py_libdir}/site-packages
a4f0b5e0 799%py_sitescriptdir %{py_scriptdir}/site-packages
31b569b6 800%py_dyndir %{py_libdir}/lib-dynload
41a62699
AF
801
802# pure python modules compilation
31b569b6 803%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699 804
31b569b6 805%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699
AF
806
807# Software written in Python language require Python with main version
5177c7b1 808%pyrequires_eq() Requires: %1
41a62699 809
ea4b2900 810# Hardlink binary identical .pyc and .pyo files
ea4b2900 811%__spec_install_post_py_hardlink {\
f67bd19e 812%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
5418b502
ER
813local a b c=0 t=0; \
814if [ -d "$RPM_BUILD_ROOT" ]; then \
815 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
816 while read a; do \
817 b="${a%.pyc}.pyo"; \
818 if cmp -s "$a" "$b"; then \
819 ln -f "$a" "$b"; \
820 c=$((c + 1)); \
821 fi; \
822 t=$((t + 1)); \
823 done < __rpm_pyc; \
824 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
825 rm -f __rpm_pyc; \
826fi; \
f67bd19e 827}; __spec_install_post_py_hardlink } }
ea4b2900 828
16f6f416 829# remove python sources, so that check-files won't complain
ea4b2900 830%py_postclean() \
e4e8948b 831for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
9ba5542a 832 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
ea4b2900
AF
833done \
834%{nil}
835
67ed5b97 836# depmod macro
837%depmod() { \
fe30b3ea 838umask 022; \
67ed5b97 839if [ -e /boot/System.map-%1 ]; then \
31b569b6 840 /sbin/depmod -a -F /boot/System.map-%1 %1; \
67ed5b97 841else \
31b569b6
ER
842 if [ -e /boot/System.map ]; then \
843 /sbin/depmod -a -F /boot/System.map %1; \
844 else \
845 /sbin/depmod -a %1; \
846 fi \
67ed5b97 847fi; \
848}
849
495892af 850# XMMS specific macros
a1551c98
ER
851%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
852%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
853%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
854%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
855%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
856%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
857%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
858%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
859%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
860%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
861
862%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
bb128216 863
e3618ee9 864# user/group checking macros
865#
866# Usage:
867# %userremove myuser
868#
869%userremove /usr/lib/rpm/user_group.sh user del
870%groupremove /usr/lib/rpm/user_group.sh group del
871#
872# Usage:
873# if %usertestrm myuser; then
874# /usr/sbin/userdel -r myuser
875# Note:
876# use these macros only if you need to call userdel/groupdel with
877# a non-standard option or take an extra action; otherwise use the
878# %userremove/%groupremove macros
879#
880%usertestrm /usr/lib/rpm/user_group.sh user testrm
881%grouptestrm /usr/lib/rpm/user_group.sh group testrm
13f70a2c
JK
882# user group membership management macros
883#
884# Usage:
885# %addusertogroup myuser agroup
886#
887%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
bfd9689c 888
889# banner support (useful in {pre,post}{,un} and triggers)
890#
891# Usage:
a980efc1 892# %banner name [-a] [-e] [-n] [-tn] <<EOF
bfd9689c 893# the banner text, the banner text
a980efc1
ER
894# the banner text, and following line
895#EOF
896# You can use any form of here-document, <<'EOF' <<-EOT will do.
897# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
898#
bfd9689c 899# -a - append to the banner
fb033326 900# -e - send to stderr instead of stdout
1257c400 901# -n - no show banner (overrides -t)
902# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
4055114a
ER
903#
904# Tests:
905# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
906# rpm -E 'date | %banner -e banner' > m; sh -x m
907#
8bea2501 908%banner(aent:) ( \
f1bbc6ff 909RPM_SCRIPTVERBOSITY=5 \
910[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
911if [ -x /usr/bin/banner.sh ]; then \
a980efc1 912 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
f1bbc6ff 913else \
fb033326 914 CMD="cat%{-e: >&2}" \
f1bbc6ff 915fi \
4055114a
ER
916eval $CMD %{?2:%2}%{?3: %3}) \
917%{nil}
1257c400 918
3c972982 919# useradd/groupadd macros
1ebc460a 920# Author: Elan Ruusamäe <glen@pld-linux.org>
29c5556c
ER
921#
922# Usage:
923# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
924# [-g initial_group] [-G group[,...]] login
925#
926# -u uid. REQUIRED
927# -g gid/group. REQUIRED
928# -s defaults to /bin/false
929# -d defaults to /usr/share/empty
930# -c No default
931# -r is accepted but ignored (it's always set)
6eb25d5d 932# -k skeleton dir. defaults to /usr/share/empty
29c5556c
ER
933# rpm specific flags
934# -P package name. defaults to %{name}
935#
29c5556c 936%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
0044d46f
ER
937%{!-u:%{error:useradd: Required argument -u missing}} \
938%{!-g:%{error:useradd: Required argument -g missing}} \
939%{!?1:%{error:useradd: Required parameter login missing}} \
29c5556c
ER
940if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
941 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
942 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
943 exit 1 \
944 fi \
945else \
946 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
947 /usr/sbin/useradd \\\
cc333c8b 948 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
29c5556c
ER
949 -u %{-u*} \\\
950 -r \\\
951 -d %{-d*}%{!-d:/usr/share/empty} \\\
952 -s %{-s*}%{!-s:/bin/false} \\\
85e3e9a1 953 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
29c5556c
ER
954 -g %{-g*} \\\
955 %{-M} \\\
956 %{-G:-G %{-G*}} \\\
6750d9f5 957 %{expand:%{%{#}}} 1>&2 || exit $? \
52e30914 958 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
29c5556c
ER
959fi;
960
29c5556c
ER
961# Usage:
962# %groupadd [-P package] [-g gid] group
963#
964# -g gid. REQUIRED
965#
966# Sample:
967# %groupadd -P %{name}-base -g %{gid} %{name}
968
969%groupadd(g:P:rfo) \
0044d46f
ER
970%{!-g:%{error:groupadd: Required argument -g missing}} \
971%{!?1:%{error:groupadd: Required parameter group missing}} \
9b773c34 972if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
29c5556c
ER
973 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
974 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
975 exit 1 \
976 fi \
977else \
978 echo "Adding group %{1} GID=%{-g*}." \
6750d9f5 979 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
52e30914 980 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
29c5556c 981fi;
053b8de1 982
55a50f1a 983# webapp macros
1ebc460a 984# Author: Elan Ruusamäe <glen@pld-linux.org>
ba42a822
ER
985#
986# The config is installed/removed inside trigger, this means that you can any
987# time install apache1/apache/lighttpd package and the configuration file is
43f81f06 988# updated. if you don't need the config for various reason for specific
ba42a822
ER
989# webserver, just remove the symlink from config directory using webapp
990# program. the trigger will not recreate the symlink on upgrades. In other
991# words the config is linked to webserver config directory on first install of
992# PACKAGE or WEBSERVER.
993#
55a50f1a
ER
994# Add package's webserver config to webserver webapps dir.
995# Usage:
217f2cb2 996# %webapp_register WEBSERVER WEBAPP
ba42a822
ER
997#
998%webapp_register() \
999%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1000if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1001 /usr/sbin/webapp register %1 %2\
1002fi\
973c1dc7 1003# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
afe4f5f0 1004if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
5f0b2e29 1005 %{expand:%service -q %%1 reload}\
ba42a822
ER
1006fi\
1007%{nil}
1008
1009# Remove package's config from webserver webapps dir.
ba42a822 1010# Usage:
b9588fe6
ER
1011# %webapp_register [-f] WEBSERVER WEBAPP
1012%webapp_unregister(f) \
ba42a822
ER
1013%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1014# remove link if either of the packages are gone \
afe4f5f0 1015if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
217f2cb2 1016 /usr/sbin/webapp unregister %1 %2\
5f0b2e29 1017 %{expand:%service -q %%1 reload}\
ba42a822
ER
1018fi \
1019%{nil}
1020
8edf8498 1021# service macro.
1ebc460a 1022# Author: Elan Ruusamäe <glen@pld-linux.org>
8edf8498
ER
1023#
1024# calls usual service restart on package %post, but skips the restart if
1025# administrator has disabled automatic service restarts in either global
1026# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1027#
8edf8498 1028# Usage:
378ae5eb 1029# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
8edf8498 1030#
dd4e969a 1031# -q be silent when service isn't started (for scriplets restaring other package's services)
378ae5eb 1032# -n NOOP mode, do not actually restart service
8edf8498 1033#
378ae5eb
ER
1034# Requirements:
1035# BuildRequires: rpmbuild(macros) >= 1.268
1036# Requires: rc-scripts
1037# -n option:
1038# BuildRequires: rpmbuild(macros) >= 1.450
1039%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
cec3a041
ER
1040
1041
91bd3172
ER
1042# Java macros. based on jpackage macros.java
1043#
1044# Root directory where all Java VMs/SDK/JREs are installed.
93406dd9 1045%_jvmdir %{_libdir}/jvm
91bd3172
ER
1046
1047# Root directory where all Java VMs/SDK/JREs expose their jars
93406dd9 1048%_jvmjardir %{_libdir}/jvm-exports
91bd3172
ER
1049
1050# Root directory for all Java VM/SDK/JRE's private things.
1051%_jvmprivdir %{_libdir}/jvm-private
1052
1053# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
93406dd9 1054%_jvmlibdir %{_libdir}/jvm
91bd3172
ER
1055
1056# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1057%_jvmdatadir %{_datadir}/jvm
1058
1059# Root directory for all configurations parts of Java VM/SDK/JRE's
1060%_jvmsysconfdir %{_sysconfdir}/jvm
1061
1062# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
29959405 1063%_jvmcommonlibdir %{_libdir}/jvm-common
91bd3172
ER
1064
1065# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
29959405 1066%_jvmcommondatadir %{_datadir}/jvm-common
91bd3172
ER
1067
1068# Root directory for all common configurations parts of Java VM/SDK/JRE's
29959405 1069%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
91bd3172
ER
1070
1071# Directory where arch-specific (JNI) version-independent jars are installed.
93406dd9 1072%_jnidir %{_libdir}/java
91bd3172 1073
a1551c98 1074%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
cec3a041 1075
95e3fc87 1076%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
43f81f06 1077%jar %{java_home}/bin/jar
a1551c98 1078%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
43f81f06
ER
1079%javac %{java_home}/bin/javac
1080%javadoc %{java_home}/bin/javadoc
cec3a041 1081
43f81f06 1082%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
cec3a041
ER
1083
1084%jpackage_script() \
a2047fce
ER
1085install -d $RPM_BUILD_ROOT%{_bindir}\
1086cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
cec3a041
ER
1087#!/bin/sh\
1088#\
1089# %{name} script\
1090# JPackage Project <http://www.jpackage.org/>\
1091\
1092# Source functions library\
1093. %{_javadir}-utils/java-functions\
1094\
1095# Source system prefs\
a2047fce 1096if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
43f81f06 1097 . %{_sysconfdir}/java/%{name}.conf\
cec3a041
ER
1098fi\
1099\
1100# Source user prefs\
a2047fce
ER
1101if [ -f $HOME/.%{name}rc ]; then\
1102 . $HOME/.%{name}rc\
cec3a041
ER
1103fi\
1104\
1105# Configuration\
1106MAIN_CLASS=%1\
1107BASE_FLAGS=%2\
1108BASE_OPTIONS=%3\
a2047fce 1109BASE_JARS="%(echo %4 | tr ':' ' ')"\
cec3a041
ER
1110\
1111# Set parameters\
1112set_jvm\
a2047fce
ER
1113set_classpath $BASE_JARS\
1114set_flags $BASE_FLAGS\
1115set_options $BASE_OPTIONS\
cec3a041
ER
1116\
1117# Let's start\
a2047fce 1118run "$@"\
cec3a041
ER
1119EOF
1120
d449d2c8
ER
1121# jpackage 1.7
1122# Directory for maven depmaps
1123#
1124%_mavendepmapdir /etc/maven
1125%_mavendepmapfragdir /etc/maven/fragments
1126
1127#
1128# add_to_depmap adds an entry to the depmap. The arguments are:
1129#
1130# %1 the original groupid
1131# %2 the original artifact id
1132# %3 the version
1133# %4 the new groupid
1134# %5 the new artifactid
1135#
1136
1137%add_to_maven_depmap() \
1138install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1139cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1140<dependency>\
1141 <maven>\
1142 <groupId>%1</groupId>\
1143 <artifactId>%2</artifactId>\
1144 <version>%3</version>\
1145 </maven>\
1146 <jpp>\
1147 <groupId>%4</groupId>\
1148 <artifactId>%5</artifactId>\
1149 <version>%3</version>\
1150 </jpp>\
1151</dependency>\
1152\
1153EOF\
1154%{nil}
1155
1156#==============================================================================
1157#
1158# update_maven_depmap updates the main maven depmap
1159#
1160%update_maven_depmap() \
1161echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1162if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1163cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1164fi\
1165echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1166
1167
e22fc3d1 1168# PEAR install macros
1ebc460a 1169# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1170#
1171# Usage:
3735468f 1172# %%pear_package_setup ...
d2a29d34 1173#
e22fc3d1 1174# -a # - also unpack SOURCE#. for PEAR bootstrapping
d2a29d34 1175# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
e22fc3d1 1176# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
3735468f
ER
1177# -D - pass -D to %setup (so the build dir is not removed)
1178# -c - register channel from local channel.xml file
d2a29d34
ER
1179#
1180# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1181# destination hierarchy. you should copy the tree to buildroot after
1182# patching/reorganizing with %%pear_package_install.
1183#
1184# additionally BUILDROOT is stripped from files and files are converted to UNIX
1185# line endings.
1186#
1187# the pear install process output is recorded to install.log, you should put it
a4f06f46 1188# to %%doc for later debug or just for information.
d2a29d34
ER
1189#
1190# additionally additional-packages.txt is produced if it was detected that the
1191# package has optional dependencies. the file format is suitable of displaying
1192# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1193# automatically added for this file.
e22fc3d1
ER
1194
1195
1196# records install.log and transforms PEAR names to PLD Linux rpm package names.
1197%__pear_install_log \
1198tee install.log \
1199# make post message of optional packages \
96e58997 1200grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
e22fc3d1
ER
1201if [ -s optional-packages.txt ]; then \
1202 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1203else \
1204 rm -f optional-packages.txt \
1205fi \
1206%{nil}
1207
1208# command invoking pear cli
1209%__pear /usr/bin/pear
1210
856feeea 1211%pear_install(a:n:zD) \
e22fc3d1 1212%__pear \\\
3735468f 1213 -c %{builddir}/pearrc \\\
d2a29d34 1214 -d doc_dir=/docs \\\
3735468f
ER
1215 -d temp_dir=/tmp \\\
1216 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
d2a29d34
ER
1217 -d bin_dir=%{_bindir} \\\
1218 -d data_dir=%{php_pear_dir}/data \\\
1219 -d test_dir=%{php_pear_dir}/tests \\\
1220 install \\\
e22fc3d1 1221 --packagingroot=%{builddir} \\\
d2a29d34
ER
1222 --offline \\\
1223 --nodeps \\\
1224 %{-f:--force} \\\
856feeea 1225 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
2a0f3b08 1226 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
856feeea
ER
1227%{nil}
1228
1229# The main macro.
1230# using this macro will append optional-packages.txt to the nocompressdoc list
1231# as it's displayed to user after package install. and adding additional gzip
1232# dep is just waste ;)
3735468f 1233%pear_package_setup(a:n:zDc:) \
856feeea
ER
1234%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1235%define builddir %{_builddir}/%{srcdir} \
1236%setup -q -c -T %{-D:-D} -n %{srcdir} \
1237%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1238%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
3735468f 1239%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
856feeea 1240%pear_install \
e22fc3d1
ER
1241%{-z:cd ..} \
1242cat %{-z:$_N/}.install.log | %__pear_install_log \
1243\
d2a29d34 1244# undos sources \
07fa2259 1245find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
d2a29d34
ER
1246%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1247%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1248%{nil}
1249
0aced28c 1250# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1ebc460a 1251# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1252%pear_package_install() \
1253cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1254find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1255# help the developer out a little: \
1256if [ -f _noautoreq ]; then \
1257 echo "AutoReqdep detected:" \
1258 echo "_noautoreq $(cat _noautoreq)" \
1259fi \
1260%{nil}
1261
54294c49
ER
1262
1263# Register OpenLDAP schema.
1ebc460a 1264# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1265#
1266# Usage:
1267# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1268#
1269# -d specify dependant schemas, separated by comma
1270#
1271%openldap_schema_register(d:) \
1272for schema in %*; do \
1273 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1274 %{__sed} -i -e " \
1275 /^include.*local.schema/{ \
1276 iinclude\\t $schema\
1277 } \
1278 " /etc/openldap/slapd.conf \
1279 fi \
1280done \
1281# enable dependant schemas \
1282if [ "%{-d*}" ]; then \
1283 %{__sed} -i -e ' \
1284 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1285 s/^#// \
1286 }' /etc/openldap/slapd.conf \
1287fi \
1288%{nil}
1289
1290# Unregister OpenLDAP schema.
1ebc460a 1291# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1292#
1293# Usage:
1294# %%openldap_schema_unregister %{schemadir}/horde.schema
1295#
1296%openldap_schema_unregister() \
1297for schema in %*; do \
1298 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1299 %{__sed} -i -e " \
1300 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1301 # for symmetry it would be nice if we disable enabled schemas in post, \
1302 # but we really can not do that, it would break something else. \
1303 " /etc/openldap/slapd.conf \
1304 fi \
1305done \
1306%{nil}
1307
feb61fae 1308%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
6ee06092 1309
a4623211 1310
1311# Build modules for kernels 2.6
1312# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1313#
1314# Usage:
650cc681 1315# %build_kernel_modules -m <modules> -C <directory>
a4623211 1316#
1317# remember that proper Makefile is still required
1318# Options:
3c972982 1319# -m <modules> (required) -- comma-separated list of modules to save,
a4623211 1320# without .ko extension, may be placed in subdirectory
650cc681 1321# -C <directory> -- change to <directory> before doing anything
a4623211 1322# -p <arg>, -P <arg> -- arguments passeed to make scripts
bf97e3a6 1323# -c -- do not execute make clean
a4623211 1324# <additional arguments> -- all additional arguments will be passed to
1325# make modules
1326#
1327# Additional patching supported via here document. Try:
1328# %build_kernel_modules -m module <<'EOF'
1329# your patch script here
1330# EOF
1331# Don't use it unless patching depends on config options.
1332
1333# Developer note: don't touch it unless you know how to handle '\'.
1334# - \ in script expands to nothing
1335# - \\\ in script expands to \
8ad8b353 1336# - \\\ inside definition expands to nothing
a4623211 1337# - \\\\\\\ inside definition expands to \
1338# - in last line \ has to touch arguments so arguments passing
1339# in new lines (using \) will be supported
1340
bf97e3a6 1341%build_kernel_modules(p:P:m:C:c) \
a4623211 1342%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1343 \
1344%define Opts \\\\\\\
1345%if "%{_target_base_arch}" != "%{_arch}" \\\
1346 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
4d45063a 1347 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
a4623211 1348 %else \\\
1349 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1350 %endif \\\
1351%else \\\
4d45063a 1352 CC="%{kgcc}" \\\
a4623211 1353%endif \
4d45063a 1354%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
a4623211 1355 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1356 \
8b51c37f 1357%{?-C:cd %{-C*}} \
a4623211 1358compile() { \
7ab1c0b6
ER
1359 local L="<" PATCH_SH; \
1360 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
a4623211 1361 set -e -x \
d606f9ca 1362 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1363 \
d606f9ca 1364for cfg in ${cfgs:-dist}; do \
a4623211 1365 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1366 \
8e042a98 1367 rm -rf o \
5f4872d8 1368 install -d o/include/linux o/arch/powerpc/lib \
a4623211 1369 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1370 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1371 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1372 \
1373 set +x \
1374 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1375 set -x \
1376 \
c940d776 1377 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
a4623211 1378 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1379 %{-p*} %{-P*} \\\
1380 %{MakeOpts} \
1381 %else \
1382 install -d o/include/config \
1383 touch o/include/config/MARKER \
21129646 1384 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
a4623211 1385 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1386 %endif \
1387 \
bf97e3a6 1388 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
a4623211 1389 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
220948bb 1390 ${1+"$@"} \\\
bf97e3a6 1391 M=$PWD %{MakeOpts}} \
220948bb 1392 \
a4623211 1393 %{__make} -C %{_kernelsrcdir} modules \\\
1394 ${1+"$@"} \\\
1395 M=$PWD %{MakeOpts} \
1396 \
1397 for MODULE in {%{-m*},}; do \
1398 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1399 done \
1400done \
650cc681 1401%{?-C:cd -} \
a4623211 1402} \
1403compile %{*}\
1404%{nil}
1405
1406
1407# Install kernel modules built by %build_kernel_modules
1408# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1409#
1410# Usage:
1411# %install_kernel_modules -m <modules> -d <directory>
1412#
1413# Options:
3c972982 1414# -m <modules> (required) -- comma-separated list of modules to install,
a4623211 1415# without .ko extension, may be placed in subdirectory
1416# -d <directory> (required) -- in what subdirectory modules should be
1417# installed (eg. misc, kernel/drivers/net)
1418# -s <suffix> -- suffix to use when installing modules, useful when module
1419# with same name exists in kernel already
1420# -n <file> -- name of modprobe config file to use (without .conf extension)
c4bd6177 1421# for defining aliases, only useful with -s
a4623211 1422
1423%install_kernel_modules(m:d:s:n:) \
1424%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1425%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1426%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1427 \
1428%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1429%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
c6bb8dfe 1430 \
d606f9ca 1431local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1432 \
1433for MODULE in {%{-m*},}; do \
1434 [ -n "${MODULE}" ] || continue \
d606f9ca
ER
1435 for cfg in ${cfgs:-dist}; do \
1436 [ "$cfg" = smp ] && suf=smp || suf= \
1437 MNAME=${MODULE##*/} \
1438 install -D ${MODULE}-$cfg.ko \\\
1439 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b37738c0 1440 %{?-s:install -d %{ModprobeD}$suf \
d606f9ca
ER
1441 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1442 >> %{ModprobeD}$suf/%{-n*}.conf} \
1443 done \
a4623211 1444done \
1445%{nil}
1446
16516cbd 1447# patchset macros
1ebc460a 1448# Author: Elan Ruusamäe <glen@pld-linux.org>
16516cbd
ER
1449#
1450# Usage:
1451# %patchset_source -f <seq(1) format> <start> [<end>]
1452# %patchset_patch <start> [<end>]
1453#
1454# If <end> is omited, it is assumed to be <start>.
1455#
1456# For example in preamble:
1457# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1458# and in %prep:
1459# %patchset_patch 33 44
1460
1461# generate SourceX urls from range START STOP
1462# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1463# The sources start from 10000
cc2d394a 1464%patchset_source(f:b:) %(
8c40a202 1465 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1466 start=$(expr $base + %1);
1467 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1468 # we need to call seq twice as it doesn't allow two formats
1469 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1470 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1471 paste %{tmpdir}/__ps{1,2};
1472 rm -f %{tmpdir}/__ps{1,2};
3b7f1777
ER
1473) \
1474%{nil}
16516cbd
ER
1475
1476# apply sources from %patchset_source
1477# -p specify -pX for %patch line
1478# -b base offset: defaults to 10000
1479%patchset_patch(f:p:b:) %(
8c40a202 1480 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1481 start=$(expr $base + %1);
1482 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1483 echo ": patchset_patch %1%{?2: to %2}";
1484 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
3b7f1777
ER
1485) \
1486%{nil}
16516cbd 1487
c7cb683a 1488# browser plugins v2
1ebc460a 1489# Author: Elan Ruusamäe <glen@pld-linux.org>
c7cb683a
ER
1490#
1491# Usage:
1492# %browser_plugins_add_browser <name> -p <plugindir>
1493#
1494# <name> (required) -- name of the browser. usually %{name}.
1495# -p <plugindir> (required) -- in what directory browser searches for its plugins.
825d0960
ER
1496# -b -- default blacklists
1497# -a <arch> override arch
c7cb683a
ER
1498#
1499# Example:
1500# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1501
1502%_browserpluginsconfdir /etc/browser-plugins
292d3658 1503%_browserpluginsdir %{_libdir}/browser-plugins
c7cb683a
ER
1504%update_browser_plugins /usr/sbin/update-browser-plugins || :
1505
825d0960 1506%browser_plugins_add_browser(p:b:a:) \
2ac4652b 1507 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
c7cb683a 1508 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
825d0960
ER
1509 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1510 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
c7cb683a
ER
1511 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1512 %{-b:cat >> $blacklist_file %{-b*}} \
1513%{nil}
1514
c879189d
ER
1515# Helper for LUA.
1516# split string separated by space into quoted list
1517#
1ebc460a 1518# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1519#
1520# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1521%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1522
1523# adjust /etc/shells by adding and removing shells from there
1ebc460a 1524# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1525#
1526# Usage:
043de7ce
ER
1527# %post -p <lua>
1528# %lua_add_etc_shells /bin/sh /bin/pdksh
c879189d 1529#
043de7ce
ER
1530# %preun -p <lua>
1531# if arg[2] == 0 then
1532# %lua_remove_etc_shells /bin/bash /bin/rbash
1533# end
378ae5eb
ER
1534#
1535# Requirements:
043de7ce
ER
1536# BuildRequires: rpmbuild(macros) >= 1.462
1537#
c879189d 1538
043de7ce 1539%lua_add_etc_shells() \
c879189d
ER
1540t = {}\
1541f = io.open("/etc/shells", "r")\
1542if f then\
1543 for l in f:lines() do t[l]=l; end\
1544 f:close()\
1545end\
1546for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1547 if not t[s] then\
b566b93e 1548 print("Adding "..s.." to /etc/shells")\
c879189d
ER
1549 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1550 end\
1551end\
1552%{nil}
1553
043de7ce
ER
1554%lua_remove_etc_shells() \
1555t = {}\
1556f = io.open("/etc/shells", "r")\
1557if f then\
1558 for l in f:lines() do t[l]=l; end\
1559 f:close()\
1560end\
1561for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1562 print("Removing "..l.." from /etc/shells")\
1563 t[l] = nil\
1564end\
1565s=""\
1566for _, l in pairs(t) do\
1567 s=s..l.."\\n"\
1568end\
1569io.open("/etc/shells", "w"):write(s)\
1570%{nil}
1571
1572# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1573#
1574# Author: Elan Ruusamäe <glen@pld-linux.org>
1575#
1576# Usage:
1577# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1578# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1579#
1580# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1581#
1582# Requirements:
1583# BuildRequires: rpmbuild(macros) >= 1.429
1584#
1585%add_etc_shells(p) %{-p:<lua>}\
1586%{expand:%%lua_add_etc_shells %*}\
1587%{nil}
1588
c879189d 1589%remove_etc_shells(p) %{-p:<lua>}\
b566b93e 1590%{-p:if arg[2] == 0 then}\
043de7ce 1591%{expand:%%lua_remove_etc_shells %*}\
39e5924d 1592%{-p:end} \
c879189d
ER
1593%{nil}
1594
4000ec89
ER
1595# Check syntax for Python files
1596#
1597# Author: Elan Ruusamäe <glen@pld-linux.org>
1598# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1599#
1600# Usage:
1601# %py_lint src
1602#
1603# Requirements:
1604# BuildRequires: python
1605# BuildRequires: rpmbuild(macros) >= 1.469
1606
1607%py_lint() \
1608__py_lint() { \
1609find "$@" -type f -name '*.py' | python -c ' \
1610import sys \
1611import compiler \
1612\
1613err = 0\
1614for f in sys.stdin: \
1615 fd = open(f.strip()) \
1616 c = fd.read() \
1617 fd.close() \
1618 try: \
1619 compiler.parse(c) \
1620 except SyntaxError, e: \
1621 print "py_lint: %s: %s" % (f.strip(), e) \
1622 err = err + 1\
1623\
1624if err: \
1625 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1626 sys.exit(1) \
1627else: \
1628 print >> sys.stderr, "py_lint: Found no syntax errors." \
1629' \
1630}; __py_lint %* \
1631%{nil}
1632
e22fc3d1 1633# vim:ts=4 sw=4 noet syn=spec
This page took 0.544178 seconds and 4 git commands to generate.